//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

#define IMG_IDX_RADIO_UNCHECKED     0
#define IMG_IDX_RADIO_CHECKED       1
#define IMG_IDX_CHECK_UNCHECKED     2
#define IMG_IDX_CHECK_CHECKED       3
#define IMG_IDX_REST                4





//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
}

TTreeNode * __fastcall TForm1::AddNode(TTreeNode * AParentNode, TNodeType ANodeType, TTreeNodeInfo::TSectionNodeType ASection, AnsiString AText, void * AData)
{
TTreeNode * TreeNode = NULL;
TTreeNodes * Items = TreeView1->Items;
TTreeNodeInfo * TreeNodeInfo = NULL;

   switch(ASection)
   {
      case TTreeNodeInfo::sntCheckBox :
         TreeNodeInfo = new TTreeNodeInfo("Check", ASection, AData);
         TreeNode = AddNode(AParentNode, ANodeType, AText, TreeNodeInfo);
         TreeNode->SelectedIndex = IMG_IDX_CHECK_UNCHECKED;
         TreeNode->ImageIndex = IMG_IDX_CHECK_UNCHECKED;
         break;
      case TTreeNodeInfo::sntRadioButton :
         TreeNodeInfo = new TTreeNodeInfo("Radio", ASection, AData);
         TreeNode = AddNode(AParentNode, ANodeType, AText, TreeNodeInfo);
         TreeNode->SelectedIndex = IMG_IDX_RADIO_UNCHECKED;
         TreeNode->ImageIndex = IMG_IDX_RADIO_UNCHECKED;
         break;
       default:
         TreeNode = AddNode(AParentNode, ANodeType, AText, NULL);
         TreeNode->SelectedIndex = IMG_IDX_REST;
         TreeNode->ImageIndex = IMG_IDX_REST;
         break;
   }


   return TreeNode;
}

void __fastcall TForm1::New()
{
//   AddNode(AParentNode, ANodeType, ASection, AText, AData);
TTreeNode * TreeNode = NULL;

   TreeNode = AddNode(NULL, ntMain, TTreeNodeInfo::sntNotDefined, "CheckBoxes", NULL);
   AddNode(TreeNode, ntChild, TTreeNodeInfo::sntCheckBox, "0", NULL);
   AddNode(TreeNode, ntChild, TTreeNodeInfo::sntCheckBox, "1", NULL);
   AddNode(TreeNode, ntChild, TTreeNodeInfo::sntCheckBox, "2", NULL);


   TreeNode = AddNode(NULL, ntMain, TTreeNodeInfo::sntNotDefined, "RadioButtons", NULL);
   AddNode(TreeNode, ntChild, TTreeNodeInfo::sntRadioButton, "0", NULL);
   AddNode(TreeNode, ntChild, TTreeNodeInfo::sntRadioButton, "1", NULL);
   AddNode(TreeNode, ntChild, TTreeNodeInfo::sntRadioButton, "2", NULL);
   AddNode(TreeNode, ntChild, TTreeNodeInfo::sntRadioButton, "3", NULL);

}
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   New();   
}
//---------------------------------------------------------------------------

__fastcall TTreeNodeInfo::TTreeNodeInfo(AnsiString Text, TTreeNodeInfo::TSectionNodeType  Section, void * Data)
{
   m_strText = Text;
   m_eSection = Section;
   m_Data = Data;
}

__fastcall TTreeNodeInfo::TTreeNodeInfo()
{
   m_strText = "Not defined";
   m_eSection = sntNotDefined;
   m_Data = NULL;
}


TTreeNode * __fastcall TForm1::AddNode(TTreeNode * AParentNode, TNodeType ANodeType, AnsiString AText, void * AData)
{
TTreeNode * TreeNode = NULL;
TTreeNodes * Items = TreeView1->Items;


   switch (ANodeType)
   {
      case ntMain :
         TreeNode = Items->AddObject(AParentNode, AText , AData);
         break;
      case ntChild :
         TreeNode = Items->AddChildObject(AParentNode, AText , AData);
         break;
   }

   return TreeNode;
}

void __fastcall TForm1::TreeView1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
TTreeNode * TreeNode;

   TreeNode = TreeView1->GetNodeAt(X, Y);

   if (TreeNode != NULL)
   {
   TTreeNodeInfo * TreeNodeInfo;
   TTreeNodeInfo::TSectionNodeType Section;


      TreeNodeInfo = (TTreeNodeInfo *)TreeNode->Data;
      Section = GetSection(TreeNode);

      switch (Section)
      {
         case TTreeNodeInfo::sntRadioButton :
            ChangeRadioButton(TreeNode);
            break;
         case TTreeNodeInfo::sntCheckBox :
            ChangeCheckBox(TreeNode);
            break;

      }
   }
}
//---------------------------------------------------------------------------


TTreeNodeInfo::TSectionNodeType __fastcall TForm1::GetSection(TTreeNode * ATreeNode)
{
   if (ATreeNode->Data != NULL)
   {
      return ((TTreeNodeInfo *)ATreeNode->Data)->eSection;
   }
   else
   {
      return TTreeNodeInfo::sntNotDefined;
   }
}

void __fastcall TForm1::ChangeCheckBox(TTreeNode * ATreeNode)
{
   if (ATreeNode->ImageIndex == IMG_IDX_CHECK_CHECKED)
   {
      ATreeNode->ImageIndex = IMG_IDX_CHECK_UNCHECKED;
      ATreeNode->SelectedIndex = IMG_IDX_CHECK_UNCHECKED;
   }
   else
   {
      ATreeNode->ImageIndex = IMG_IDX_CHECK_CHECKED;
      ATreeNode->SelectedIndex = IMG_IDX_CHECK_CHECKED;
   }
}

void __fastcall TForm1::ChangeRadioButton(TTreeNode * ATreeNode)
{
TTreeNode * ParentNode;
int iCount;

   ParentNode = ATreeNode->Parent;

   iCount = ParentNode->Count;

   for (int iCounter=0; iCounter<iCount; iCounter++)
   {
   TTreeNode * TreeNode;
   TTreeNodeInfo::TSectionNodeType Section;

      TreeNode = ParentNode->Item[iCounter];
      Section = GetSection(TreeNode);

      if (Section == TTreeNodeInfo::sntRadioButton)
      {
         TreeNode->ImageIndex = IMG_IDX_RADIO_UNCHECKED;
         TreeNode->SelectedIndex = IMG_IDX_RADIO_UNCHECKED;
      }
   }

   ATreeNode->ImageIndex = IMG_IDX_RADIO_CHECKED;
   ATreeNode->SelectedIndex = IMG_IDX_RADIO_CHECKED;

}




